;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; M2 - MailTo
;; by bunkahumpa
;; bunkahumpa@playcs.com
;; last updated December 12, 2003
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

on *:load:{
  if ((!$exists($scriptdirm2options.ini)) || (!$exists($scriptdirsend.ico)) || (!$exists($scriptdirclear.ico)) || (!$exists($scriptdirchecked.ico)) || (!$exists($scriptdirunchecked.ico)) || (!$exists($scriptdircancel.ico)) || (!$exists($scriptdirmdx.dll)) || (!$exists($scriptdirviews.mdx)) || (!$exists($scriptdirbars.mdx)) || (!$exists($scriptdirctl_gen.mdx))) {
    var %error $input(Some vital files are missing - unzip all of files!,o)
  }
  else {
    echo -a -
    echo -a *** MailTo has been loaded successfully!
    echo -a To use, right-click and select MailTo from the popup window
    echo -a -
  }
}

menu status,channel,query,nicklist,menubar {
  -
  M2 - MailTo:{
    if (!$dialog(mailto)) {
      unset %m2.*
      unset %mailto.*
      dialog -dm mailto mailto
    }
    else {
      dialog -v mailto mailto
    }
  }
  M2 - Address Book: $iif(!$dialog(address_book),dialog -dm address_book address_book,dialog -v address_book address_book)
  -
}

dialog mailto {
  title "M2 - MailTo"
  size -1 -1 204 168
  option dbu
  box "", 1, 1 -2 202 137
  text "From:", 9, 7 7 16 8
  text "To:", 10, 7 17 10 8
  text "Cc:", 11, 7 27 10 8
  text "Bcc:", 12, 7 37 11 8
  edit "", 13, 34 6 110 10, autovs
  edit "", 14, 34 16 110 10, autovs
  edit "", 15, 34 26 110 10, autovs
  edit "", 16, 34 36 110 10, autovs
  text "Subject:", 17, 7 49 25 8
  edit "", 18, 34 48 164 10, autovs
  edit "", 19, 7 60 191 56, multi return autovs vsbar
  box "", 24, 1 131 103 26
  box "", 25, 103 131 100 26
  box "", 26, 1 153 202 14
  text Status, 27, 2 158 199 7, right
  button "Cancel", 53, 1 1 9 9, hide cancel
  button "A", 28, 146 17 9 9
  button "A", 29, 146 27 9 9
  button "A", 30, 146 37 9 9
  list 31, 23 140 78 13, size
  list 32, 158 140 42 13, size
  list 35, 113 140 42 13, size
  text "Signature:", 33, 164 18 27 8, disable
  text "", 34, 164 26 34 8
  text "Attached:", 20, 7 121 26 8
  edit "", 21, 34 120 125 10, autohs
  button "Browse", 23, 161 120 37 10
  menu "File", 2
  item "Load Draft...", 4, 2
  item "Save Draft...", 49, 2
  item break, 50, 2
  item "Options", 3, 2
  item "Address Book", 51, 2
  item break, 52, 2
  item "Close", 5, 2
  menu "Help", 6
  item "Help", 7, 6
  item "About", 8, 6
}

;Aliases for MDX
alias -l mdx-info {
  var %dname, %did
  if ($0 = 1) {
    set %dname $dname
    set %did $1
  }
  else {
    set %dname $1
    set %did $2
  }
  did -i %dname %did 1 page $prop
  return $gettok($did(%dname, %did, 1), 3-, 32)
}
alias -l icons {
  return $scriptdir $+ / $+ $1
}
alias -l mdx {
  if ( $2- == $null ) return $dll($udll,$1,.)
  return $dll($udll,$1,$2-)
}
alias -l udll return $+(",$scriptdir,mdx.dll,")
alias -l vdll return $+($scriptdir,views.mdx)
alias -l bdll return $+($scriptdir,bars.mdx)
alias -l gdll return $+($scriptdir,ctl_gen.mdx)

on *:dialog:mailto:init:0:{
  set %m2.checked no
  if ($readini($+($shortfn($scriptdir),m2options.ini),options,email)) {
    did -a mailto 13 $readini(m2options.ini,options,email)
  }
  if ($readini($+($shortfn($scriptdir),m2options.ini),options,smtp)) {
    set %mailto.smtp $readini($+($shortfn($scriptdir),m2options.ini),options,smtp)
  }
  else {
    set %mailto.smtp smtp.comcastnet
  }
  if ($readini($+($shortfn($scriptdir),m2options.ini),options,sigenabled) == on) {
    did -a mailto 34 Enabled
  }
  else {
    did -a mailto 34 Disabled
  }
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  mdx SetControlMDX 31 toolbar arrows nodivider list noresize flat > [ $bdll ]
  mdx SetBorderStyle 31
  did -i $dname 31 1 bmpsize 16 16
  did -i $dname 31 1 setimage icon small $icons(clear.ico)
  did -i $dname 31 1 setimage icon small $icons(cancel.ico)
  did -a $dname 31 +a 1 Clear $+ $chr(9) $+ Clear
  did -a $dname 31 -
  did -a $dname 31 +a 2 Cancel $+ $chr(9) $+ Cancel
  mdx SetControlMDX 32 toolbar arrows nodivider list noresize flat > [ $bdll ]
  mdx SetBorderStyle 32
  did -i $dname 32 1 bmpsize 16 16
  did -i $dname 32 1 setimage icon small $icons(send.ico)
  did -a $dname 32 +a 1 Send! $+ $chr(9) $+ Send!
  mdx SetControlMDX 35 toolbar arrows nodivider list noresize flat > [ $bdll ]
  mdx SetBorderStyle 35
  did -i $dname 35 1 bmpsize 16 16
  did -i $dname 35 1 setimage icon small $icons(unchecked.ico)
  did -a $dname 35 +a 1 Save Draft $+ $chr(9) $+ Save Draft
}

dialog m2about {
  title "M2 - MailTo"
  size -1 -1 89 46
  option dbu
  text "M2 - MailTo", 1, 9 7 30 7
  button "Close", 2, 29 31 31 10, ok
  box "", 3, 1 -2 87 47
  text "by bunkahumpa", 4, 9 14 43 8
  text "bunkahumpa@playcs.com", 5, 9 22 65 8
}

dialog m2options {
  title "MailTo - Options"
  size -1 -1 123 101
  option dbu
  box "", 1, 1 -2 121 102
  text "Your Default E-Mail:", 2, 6 6 50 8
  edit "", 3, 6 15 110 10
  text "SMTP Server:", 4, 6 28 35 8
  edit "", 5, 6 37 110 10
  button "Save Changes", 6, 6 86 40 10
  button "Cancel", 7, 49 86 37 10
  text "Your Signature:", 8, 6 50 43 8
  edit "", 9, 6 59 110 24, multi return autovs vsbar
  check "Enable?", 10, 87 49 28 10, left
}

on *:dialog:m2options:init:0:{
  set %m2.optionsemail $readini($+($shortfn($scriptdir),m2options.ini),options,email)
  set %m2.optionssmtp $readini($+($shortfn($scriptdir),m2options.ini),options,smtp)
  did -a m2options 3 %m2.optionsemail
  did -a m2options 5 %m2.optionssmtp
  if ($readini($+($shortfn($scriptdir),m2options.ini),options,sigenabled) == on) {
    did -c m2options 10
  }
  if ($readini($+($shortfn($scriptdir),m2options.ini),signature,1)) {
    var %sig 1
    while (%sig <= $ini($+($shortfn($scriptdir),m2options.ini),signature,0)) {
      did -i m2options 9 %sig $readini($+($shortfn($scriptdir),m2options.ini),signature,%sig)
      inc %sig
    }
  }
}

on *:dialog:m2options:sclick:6:{
  if ($did(m2options,3)) {
    writeini $+($shortfn($scriptdir),m2options.ini) options email $did(m2options,3)
    did -o mailto 13 1 $did(m2options,3)
  }
  if ($did(m2options,5)) {
    writeini $+($shortfn($scriptdir),m2options.ini) options smtp $did(m2options,5)
    if ($dialog(mailto)) {
      set %mailto.smtp $did(m2options,5)
    }
  }
  if ($did(m2options,10).state == 1) {
    writeini $+($shortfn($scriptdir),m2options.ini) options sigenabled on
    did -o mailto 34 1 Enabled
  }
  else {
    writeini $+($shortfn($scriptdir),m2options.ini) options sigenabled off
    did -o mailto 34 1 Disabled
  }
  if ($did(m2options,9)) {
    remini $+($shortfn($scriptdir),m2options.ini) signature
    if ($did(m2options,9,$did(m2options,9).lines) == $null) {
      var %line = 1  
      while (%line < $did(m2options,9).lines) {
        writeini $+($shortfn($scriptdir),m2options.ini) signature %line $did(m2options,9,%line)
        inc %line
      }
    }
    else {
      var %line = 1
      while (%line <= $did(m2options,9).lines) {
        writeini $+($shortfn($scriptdir),m2options.ini) signature %line $did(m2options,9,%line)
        inc %line
      }
    }
  }
  unset %m2.optionsemail
  unset %m2.optionssmtp
  dialog -x m2options m2options
}

on *:dialog:m2options:sclick:7:{
  unset %m2.optionsemail
  unset %m2.optionssmtp
  dialog -x m2options m2options
}

dialog m2sent {
  title "M2 - MailTo"
  size -1 -1 89 35
  option dbu
  text "Your message has been sent!", 1, 9 7 75 8
  button "Close", 2, 29 19 31 10
  box "", 3, 1 -1 87 34
}

alias -l m2.savedraft {
  set %m2.savedraft $nopath($sfile(*.m2,Save))
  if ($len(%m2.savedraft) < 4) {
    var %m2.error $input(You must include a filename!,o)
    halt
  }
  if ($exists(%m2.savedraft)) {
    set %m2.overwrite $input(Over-write %m2.savedraft $+ ?,yvq,Over-write?)
    if (%m2.overwrite == $no) {
      halt
    }
    else {
      goto save
    }
  }
  else {
    :save
    if ($right(%m2.savedraft,3) != .m2) {
      set %m2.savedraft %m2.savedraft $+ .m2
    }
    did -o mailto 27 1 Saving Draft ' $+ %m2.savedraft $+ '...
    hmake m2Draft 3
    hadd m2Draft From $did(mailto,13)
    hadd m2Draft To $did(mailto,14)
    hadd m2Draft Cc $did(mailto,15)
    hadd m2Draft Bcc $did(mailto,16)
    hadd m2Draft Subject $did(mailto,18)
    if ($did(mailto,19).lines > 0) {
      var %m2.bodylines = 1
      while (%m2.bodylines <= $did(mailto,19).lines) {
        hadd m2Draft Body $+ %m2.bodylines $did(mailto,19,%m2.bodylines)
        inc %m2.bodylines
      }
    }
    else {
      hadd m2Draft Body1 $did(mailto,19)
    }
    hsave -ou m2Draft %m2.savedraft
    hfree m2Draft
    did -o mailto 27 1 Saved Draft ' $+ %m2.savedraft $+ '
  }
}

alias -l m2.clear {
  did -r mailto 13 
  did -r mailto 14
  did -r mailto 15
  did -r mailto 16
  did -r mailto 18
  did -r mailto 19
  did -r mailto 21
  unset %mailto.attachment
  if ($readini($+($shortfn($scriptdir),m2options.ini),options,email)) {
    did -a mailto 13 $readini($+($shortfn($scriptdir),m2options.ini),options,email)
  }
}

on *:dialog:m2sent:sclick:2:{
  dialog -x m2sent m2sent
}

on *:dialog:mailto:menu:3:{
  if (!$dialog(m2options)) {
    dialog -dm m2options m2options 
  }
}

on *:dialog:mailto:menu:51:{
  if (!$dialog(address_book)) {
    dialog -dm address_book address_book 
  }
}

on *:dialog:mailto:menu:4:{
  set %m2.loaddraft $nopath($sfile(*.m2))
  if ($exists(%m2.loaddraft)) {
    did -o mailto 27 1 Loading Draft ' $+ %m2.loaddraft $+ '...
    if ($hget(m2Draft,0).item) {
      hfree m2Draft
    }
    hmake m2Draft 3
    hload m2Draft %m2.loaddraft
    did -r mailto 13 $hget(m2Draft,From)
    did -i mailto 13 1 $hget(m2Draft,From)
    did -r mailto 14 $hget(m2Draft,To)
    did -i mailto 14 1 $hget(m2Draft,To)
    did -r mailto 15 $hget(m2Draft,Cc)
    did -i mailto 15 1 $hget(m2Draft,Cc)
    did -r mailto 16 $hget(m2Draft,Bcc)
    did -i mailto 16 1 $hget(m2Draft,Bcc)
    did -r mailto 18 $hget(m2Draft,Subject)
    did -i mailto 18 1 $hget(m2Draft,Subject)
    did -r mailto 19 $hget(m2Draft,Body)
    var %m2.bodylength = 1
    var %m2.bodylines = $hfind(m2Draft,Body*,0,w)
    while (%m2.bodylength <= %m2.bodylines) {
      did -i mailto 19 %m2.bodylength $hget(m2Draft,Body $+ %m2.bodylength)
      inc %m2.bodylength
    }
    hfree m2Draft
    did -o mailto 27 1 Loaded Draft ' $+ %m2.loaddraft $+ '
  }
  else {
    var %m2.noexist = $input(That file does not exist or you did not select a file.,o)
  }
}

on *:dialog:mailto:menu:49:{
  m2.savedraft
}

on *:dialog:mailto:menu:5:{
  dialog -x mailto mailto
}

on *:dialog:mailto:menu:7:{
  run $scriptdirm2readme.html
}

on *:dialog:mailto:menu:8:{
  if (!$dialog(m2about)) {
    dialog -dm m2about m2about
  }
}

on *:dialog:mailto:sclick:23:{
  set %mailto.attachment $shortfn($sfile(*.*,Select an Attachment))
  did -o mailto 21 1 %mailto.attachment
}

on *:dialog:mailto:sclick:28:{
  if (!$dialog(address_book)) {
    set %m2.addressto 1
    dialog -dm address_book address_book
  }
}

on *:dialog:mailto:sclick:29:{
  if (!$dialog(address_book)) {
    set %m2.addresscc 1
    dialog -dm address_book address_book
  }
}

on *:dialog:mailto:sclick:30:{
  if (!$dialog(address_book)) {
    set %m2.addressbcc 1
    dialog -dm address_book address_book
  }
}

on *:dialog:mailto:sclick:31:{
  var %click $did($dname,31).sel
  if (%click == 2) {
    m2.clear
  }
  elseif (%click == 4) {
    unset %mailto.smtp
    dialog -c mailto
  }
}

on *:dialog:mailto:sclick:32:{
  var %click $did($dname,32).sel
  if (%click == 2) {
    if (%m2.checked == yes) {
      m2.savedraft
    }
    if ((!$did(mailto,13)) || (!$did(mailto,14))) {
      var %m2.error $input(You must enter a from and to address!,o)
    }
    else {
      if ((*@*.* !iswm $did(mailto,13)) || (*@*.* !iswm $did(mailto,13))) {
        var %m2.error $input(Incorrect E-Mail format.,0)
      }
      if ($did(mailto,15)) {
        if (*@*.* !iswm $did(mailto,15)) {
          var %m2.error $input(Incorrect E-Mail format.,0)
        }
        else {
          set %m2.cc 1 
        }
      }
      if ($did(mailto,16)) {
        if (*@*.* !iswm $did(mailto,16)) {
          var %m2.error $input(Incorrect E-Mail format.,0)
        }
        else {
          set %m2.bcc 1 
        }
      }
      mailto
    }
  }
}

on *:dialog:mailto:sclick:35:{
  var %click $did($dname,35).sel
  if (%click == 2) {
    if (%m2.checked == no) {
      set %m2.checked yes
      did -o $dname 35 1 bmpsize 16 16
      did -o $dname 35 1 setimage icon small $icons(checked.ico)
    }  
    else {
      set %m2.checked no
      did -o $dname 35 1 bmpsize 16 16
      did -o $dname 35 1 setimage icon small $icons(unchecked.ico)
    }
  }
}

alias -l mailto {
  set %mailto.email $did(mailto,14)
  set %mailto.from $did(mailto,13)
  if (%m2.cc) {
    set %mailto.cc $did(mailto,15)
  }
  if (%m2.bcc) {
    set %mailto.bcc $did(mailto,16)
  }
  set %mailto.subject $did(mailto,18)
  if ($sock(mailto)) {
    sockclose mailto
  }
  sockopen mailto %mailto.smtp 25
}

; this is used for scripters to use mailto in their own scripts
; the format is:
; /scriptmailer smtp.server.domain from to ^ subject ^ body
; the ^ and ^ seperate the header stuff from the subject and the subject from the body
alias scriptmailer {
  if (!$7) {
    echo -a Insufficient Parameters.
    echo -a Correct Format: /scriptmailer smtp.server.domain from to ^ subject ^ body
  }
  else {
    if ((*@*.* !iswm $2) || (*@*.* !iswm $3)) {
      echo -a incorrect e-mail format 
      halt
    }
    if (*^*^* !iswm $1-) {
      echo -a Insufficient Parameters.
      echo -a You are missing the dividers (^)
      echo -a Correct Format: /scriptmailer smtp.server.domain from to ^ subject ^ body
      halt
    }
    else {
      set %mailto.smtp $1
      set %mailto.from $2
      set %mailto.email $3
      set %mailto.subject $gettok($1-,-2,94)
      set %mailto.body $gettok($1-,-1,94)
      if ($sock(mailto)) {
        sockclose mailto
      }
      sockopen mailto %mailto.smtp 25
    }
  }
}

on *:sockopen:mailto:{
  if ($sockerr > 0) {
    if (%mailto.body) {
      echo -a Error: Unable to contact server
      unset %mailto.email
      unset %mailto.from
      unset %mailto.subject
      unset %mailto.body
    }
    else {
      did -o mailto 27 1 Error: Unable to contact server
    }
    sockclose $sockname
    halt
  }
  if (%mailto.body) {
    echo -a PLEASE WAIT - Contacting server...
  }
  else {
    did -o mailto 27 1 PLEASE WAIT - Contacting server...
  }
  set %mailto.step 1
}

on *:sockread:mailto:{
  sockread %mailto.data 
  if (220* iswm %mailto.data) {
    sockwrite -tn $sockname HELO $ip
  }
  if (250* iswm %mailto.data) {
    if (%mailto.step == 1) { 
      inc %mailto.step
      sockwrite -tn $sockname MAIL FROM: %mailto.from
      if (%mailto.body) {
        echo -a PLEASE WAIT - Sender Sent
        halt
      }
      else {
        did -o mailto 27 1 PLEASE WAIT - Sender Sent
        halt
      }
    }
    if (%mailto.step == 2) {
      inc %mailto.step
      sockwrite -tn $sockname RCPT TO: %mailto.email
      if (%mailto.body) {
        echo -a PLEASE WAIT - Recipient Sent
      }
      else {
        did -o mailto 27 1 PLEASE WAIT - Recipient Sent
      }
      if (%mailto.cc) {
        sockwrite -tn $sockname RCPT TO: %mailto.cc
        did -o mailto 27 1 PLEASE WAIT - Cc Sent
      }
      if (%mailto.bcc) {
        sockwrite -tn $sockname RCPT TO: %mailto.bcc
        did -o mailto 27 1 PLEASE WAIT - Bcc Sent
      }
      halt
    }
    if (%mailto.step == 3) { 
      unset %mailto.step
      sockwrite -tn $sockname DATA
      if (%mailto.body) {
        echo -a PLEASE WAIT - Data Sent
      }
      else {
        did -o mailto 27 1 PLEASE WAIT - Data Sent
      }
    }
    if (%mailto.step == end) {
      unset %mailto.step
      sockwrite -tn $sockname QUIT
      sockclose $sockname
      if ($dialog(mailto)) {
        did -o mailto 27 1 Disconnected from server
      }
      else {
        echo -a Disconnected from server
      }
    }
  }
  if (354* iswm %mailto.data) {
    if (%mailto.body) {
      echo -a PLEASE WAIT - Sending Message...
    }
    else {
      did -o mailto 27 1 PLEASE WAIT - Sending Message...
    }
    sockwrite -tn $sockname From: %mailto.from
    sockwrite -tn $sockname To: %mailto.email
    if (%mailto.cc) {
      sockwrite -tn $sockname Cc: %mailto.cc
    }
    if (%mailto.bcc) {
      sockwrite -tn $sockname Bcc: %mailto.bcc
    }
    sockwrite -tn $sockname Subject: %mailto.subject
    sockwrite -tn $sockname X-Mailer: MailTo by bunkahumpa
    sockwrite -tn $sockname Mime-Version: 1.0
    sockwrite -tn $sockname Content-Type: MULTIPART/MIXED; BOUNDARY="mailtoboundary"
    sockwrite -tn $sockname
    sockwrite -tn $sockname --mailtoboundary
    sockwrite -tn $sockname Content-Type: TEXT/PLAIN; charset=US-ASCII
    sockwrite -tn $sockname
    if (%mailto.body) {
      echo -a PLEASE WAIT - Headers Sent
    }
    else {
      did -o mailto 27 1 PLEASE WAIT - Headers Sent
    }
    if (%mailto.body) {
      sockwrite -tn $sockname %mailto.body
      sockwrite -tn $sockname .
      set %mailto.step end
      echo -a Message Sent
      unset %mailto.email
      unset %mailto.from
      unset %mailto.subject
      unset %mailto.body
    }
    else {
      var %mailto.bodylines = 1
      while (%mailto.bodylines <= $did(mailto,19).lines) {
        sockwrite -tn $sockname $did(mailto,19,%mailto.bodylines)
        inc %mailto.bodylines
      }
      if ($readini($+($shortfn($scriptdir),m2options.ini),options,sigenabled) == on) {
        var %line 1
        sockwrite -tn $sockname ---------------------------
        while (%line <= $ini($+($shortfn($scriptdir),m2options.ini),signature,0)) {
          sockwrite -tn $sockname $readini($+($shortfn($scriptdir),m2options.ini),signature,%line)
          inc %line
        }
      }
      if (%mailto.attachment) {
        did -o mailto 27 1 PLEASE WAIT - Sending Attachment (mIRC may freeze, wait for it)
        sockwrite -tn $sockname
        sockwrite -tn $sockname --mailtoboundary
        sockwrite -tn $sockname Content-Type: APPLICATION/octet-stream; name= $+ $gettok(%mailto.attachment,-1,92)
        sockwrite -tn $sockname Content-Transfer-Encoding: BASE64                                          
        sockwrite -tn $sockname Content-Disposition: attachment; filename= $+ $gettok(%mailto.attachment,-1,92)
        sockwrite -tn $sockname
        if ($exists(temp.txt)) {
          write -c temp.txt
        }
        .echo -ta $base64enc(%mailto.attachment,write temp.txt)
        var %line = 1
        while (%line <= $lines(temp.txt)) {
          sockwrite -tn $sockname $read(temp.txt,%line)
          inc %line
        }
        did -o mailto 27 1 Attachment Sent
        sockwrite -tn $sockname --mailtoboundary--
      }
      unset %mailto.data
      sockwrite -tn $sockname .
      set %mailto.step end
      did -o mailto 27 1 Message Sent
      m2.clear
      dialog -dvm m2sent m2sent
    }
  }
  if ($gettok(%mailto.data,1,32) > 499) {
    if (%mailto.body) {
      echo -a Error: $gettok(%mailto.data,2-,32)
    }
    else {
      did -o mailto 27 1 Error: $gettok(%mailto.data,2-,32)
    }
    sockclose $sockname 
  }
}

on *:sockclose:mailto:{ 
  sockclose $sockname
  if (%mailto.body) {
    echo -a Connection Interrupted
  }
  else {
    did -o mailto 27 1 Connection Interrupted
  }
}

on *:dialog:mailto:close:0:{
  unset %mailto*
  unset %m2*
}

dialog address_book {
  title "MailTo: Address Book"
  size -1 -1 127 121
  option dbu
  box "", 1, 0 -3 127 124
  list 2, 5 40 117 64, size hsbar vsbar
  edit "", 3, 5 15 117 10, autovs
  button "Add", 4, 5 26 37 10, disable
  button "Remove", 5, 45 107 37 10, disable
  button "Edit", 6, 5 107 37 10, disable
  text "Add an E-Mail address to your address book:", 7, 5 5 112 8
  button "Close", 8, 85 107 37 10
  button "Insert into E-Mail ", 9, 64 26 58 10, disable
}

on *:dialog:address_book:init:0:{
  var %ini = 1
  while (%ini <= $ini($+($shortfn($scriptdir),m2options.ini),addresses,0)) {
    did -a address_book 2 $readini($+($shortfn($scriptdir),m2options.ini),addresses,%ini)
    inc %ini
  }
}

on *:dialog:address_book:sclick:2:{
  if ($did(address_book,2).sel) {
    did -e address_book 5,6 
  }
  if ($dialog(mailto)) {
    if ($did(address_book,2).sel) {
      if ((%m2.addressto) || (%m2.addresscc) || (%m2.addressbcc)) {
        did -e address_book 9
      }
    }
  }
}

on *:dialog:address_book:edit:3:{
  did -e address_book 4
}

on *:dialog:address_book:sclick:4:{
  if ($did(address_book,3)) {
    if (*@*.* !iswm $did(address_book,3)) {
      var %m2.error $input(Incorrect E-Mail Format.,o)
    }
    else {
      did -a address_book 2 $did(address_book,3)
      writeini $+($shortfn($scriptdir),m2options.ini) addresses $calc($ini($+($shortfn($scriptdir),m2options.ini),addresses,0) + 1) $did(address_book,3)
      did -r address_book 3
    }
  }
}

on *:dialog:address_book:sclick:5:{
  if ($did(address_book,2).sel) {
    if ($did(address_book,2).sel < $ini($+($shortfn($scriptdir),m2options.ini),addresses,0)) {
      var %line = $did(address_book,2).sel
      while (%line <= $ini($+($shortfn($scriptdir),m2options.ini),addresses,0)) {
        writeini $+($shortfn($scriptdir),m2options.ini) addresses %line $readini($+($shortfn($scriptdir),m2options.ini),addresses,$calc(%line + 1))
        inc %line
        if (%line == $ini($+($shortfn($scriptdir),m2options.ini),addresses,0)) {
          remini $+($shortfn($scriptdir),m2options.ini) addresses %line
          did -d address_book 2 $did(address_book,2).sel
        }
      }
    }
    else {
      remini $+($shortfn($scriptdir),m2options.ini) addresses $did(address_book,2).sel
      did -d address_book 2 $did(address_book,2).sel
    }
  }
}

on *:dialog:address_book:sclick:6:{
  set %m2.editemailline $did(address_book,2).sel
  set %m2.editemail $did(address_book,2).seltext
  dialog -dm edit_email edit_email
}

on *:dialog:address_book:sclick:8:{
  dialog -x address_book address_book
}

on *:dialog:address_book:sclick:9:{
  if ($did(address_book,2).sel) {
    if ($dialog(mailto)) {
      if (%m2.addressto) {
        did -o mailto 14 1 $did(address_book,2).seltext
        unset %m2.addressto
        dialog -x address_book address_book
      }
      if (%m2.addresscc) {
        did -o mailto 15 1 $did(address_book,2).seltext
        unset %m2.addresscc
        dialog -x address_book address_book
      }
      if (%m2.addressbcc) {
        did -o mailto 16 1 $did(address_book,2).seltext
        unset %m2.addressbcc
        dialog -x address_book address_book
      }
    }
  }
}

dialog edit_email {
  title "Edit Email Address"
  size -1 -1 125 44
  option dbu
  box "", 1, 0 0 125 44
  text "Edit the selected address:", 2, 5 9 64 8
  edit "", 3, 5 18 115 10
  button "Save", 5, 5 30 37 10
  button "Cancel", 6, 45 30 37 10
}

on *:dialog:edit_email:init:0:{
  did -a edit_email 3 %m2.editemail
}

on *:dialog:edit_email:sclick:5:{
  if ($did(edit_email,3)) {
    if (*@*.* !iswm $did(edit_email,3)) {
      var %m2.error $input(Incorrect E-Mail Format.,o)
    }
    else {
      writeini $+($shortfn($scriptdir),m2options.ini) addresses %m2.editemailline $did(edit_email,3)
      did -o address_book 2 %m2.editemailline $did(edit_email,3)
      unset %m2.editemailline
      unset %m2.editemail 
      dialog -x edit_email edit_email
    }
  }
  else {
    var %m2.error $input(You must provide an E-Mail address!,o)
  }
}

on *:dialog:edit_email:sclick:6:{
  unset %m2.editemailline
  unset %m2.editemail
  dialog -x edit_email edit_email
}

; thanks to ash from #scripters on austnet for this
alias -l base64enc {
  var %i,%x,%binstr,%6num,%linestr,%6str,%char,%file = $1,%cmd = $2
  if ($fopen(mailto.attach)) .fclose mailto.attach
  if (!$exists(%file)) {
    if ($dialog(mailto)) {
      did -o mailto 27 1 Error: file doesn't exist
    }
    echo -ta Error: file doesn't exist
    return
  }
  .fopen mailto.attach %file
  %i = 0
  while ($feof == 0) {
    %char = $fgetc(mailto.attach)
    if ($feof) break
    inc %i
    %binstr = $+(%binstr,$base(%char,10,2,8))
    if ($calc(%i % 3) == 0) {
      %x = 0
      %6str =
      while (%x < 4) {
        %6num = $base($mid(%binstr,$calc(%x * 6 + 1),6),2,10)
        %6num = $base64.getchar(%6num)
        %6str = $+(%6str,%6num)
        inc %x
      }
      %binstr =
      %linestr = $+(%linestr,%6str)
      if ($len(%linestr) == 72) {
        %cmd %linestr
        %linestr =
      }
    }
  }
  if ($calc(%i % 3) != 0) {
    %binstr = $+(%binstr,$str(0,$calc((3 - (%i % 3)) * 8)))
    %6str = $base64.getchar($base($mid(%binstr,0,6),2,10))
    if ($calc(%i % 3) == 2) {
      %6str = $+(%6str,$base64.getchar($base($mid(%binstr,0,6),2,10)))
    }
    else {
      %6str = $+(%6str,=)
    }
    %6str = $+(%6str,=)
  }
  %linestr = $+(%linestr,%6str)
  %cmd %linestr
  .fclose mailto.attach
  return File Attachment Successfully Attached
}

alias -l base64.getchar {
  if ($1 < 26) {
    return $chr($calc($asc(A) + $1))
  }
  elseif ($1 < 52) {
    return $chr($calc($asc(a) + ($1 - 26)))
  }
  elseif ($1 < 62) {
    return $chr($calc($asc(0) + ($1 - 52)))
  }
  elseif ($1 == 62) {
    return +
  }
  else {
    return /
  }
}
